# When included, it will compile, assemble, and link all .c.h and .asm files
# Some variables
THISPATH := $(abspath $(lastword $(MAKEFILE_LIST)))
CURDIR := $(notdir $(patsubst %/,%,$(dir $(THISPATH))))

# Toolchain
CC = /usr/bin/cmoc
AS = /usr/bin/lwasm
AR = /usr/bin/lwar
LD = /usr/bin/lwlink

# Project src
SRC_ROOT := $(PACKAGE)

LIBS := $(shell find ./libs -maxdepth 1 -type d) \
	/usr/lib/gcc/m6809-unknown/4.6.4/ \
	/usr/share/cmoc/include \
	/usr/share/cmoc/lib
LIBOPTS := $(foreach lib,$(LIBS), -L$(lib))

HEADERS := $(wildcard $(SRC_ROOT)\*.h)
INCOPTS := $(foreach inc,$(HEADERS:.h=), -l$(inc))

SRCS := $(wildcard $(SRC_ROOT)/*.c)
ASMS := $(wildcard $(SRC_ROOT)/*.asm)
CLEAN := $(wildcard $(SRC_ROOT)/*.o)
OBJS := $(SRCS:.c=.o) $(ASMS:.asm=.o)
DEPS := $(SRCS:.c=.d) $(ASMS:.asm=.d)

# Flags
ASFLAGS=--format=raw
CFLAGS=--void-target
LDFLAGS=

$(PACKAGE): $(OBJS)
	$(CC) $(CFLAGS) --org=$(ORG) -o $@.bin $< $(LIBOPTS)

%.o: $(SRC_ROOT)/%.c
	$(CC) $(CFLAGS) -o $@ -c $< $(LIBOPTS)

%.o: $(SRC_ROOT)/%.asm
	$(AS) $(ASFLAGS) -o $@ $< $(LIBOPTS)

# Automatic prerequisite generation.
#%.d: $(SRC_ROOT)/%.c
#	$(CC) --deps-only $(CFLAGS) $<
#%.d: $(SRC_ROOT)/%.asm
#	$(AS) --deps-only $(CFLAGS) $<

clean:
	rm -f $(SRC_ROOT)/$(PACKAGE).bin $(CLEAN) $(DEPS) $(wildcard $(SRC_ROOT)/*.d) $(wildcard *.d)

